﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using DnsClient;
using MailKit.Net.Smtp;
using MailKit;
using MimeKit;


namespace MXMailerExample.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            return View();
        }

        public ActionResult About()
        {
            ViewBag.Message = "Your application description page.";

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";
            //
            var client = new LookupClient();
            client.UseCache = true;
            var result = client.Query("gmail.com", QueryType.MX);

            foreach (var x in result.Answers)
            {
                var X = x as DnsClient.Protocol.MxRecord;
                var y = X.Exchange;

                var message = new MimeMessage();
                message.From.Add(new MailboxAddress("Mr Test", "me@myaddress.co.uk"));
                message.To.Add(new MailboxAddress("Mrs Recipient Name", "them@gmail.com"));
                message.Subject = "Weekly report from system";

                message.Body = new TextPart("plain")
                {

                    Text = @"Hi there, your weekly test message is available here"
                };

                AttachmentCollection att = new AttachmentCollection();
                try
                {
                    using (var smclient = new SmtpClient())
                    {
                        // For demo-purposes, accept all SSL certificates (in case the server supports STARTTLS)
                        smclient.ServerCertificateValidationCallback = (s, c, h, e) => true;
                        smclient.Connect(y, 25, false);

                        // Note: only needed if the SMTP server requires authentication
                        //mclient.Authenticate("joey", "password");
                        smclient.Send(message);
                        smclient.Disconnect(true);
                        ViewBag.Message = "Message sent successfully!";
                        break;
                    }
                }
                catch (Exception ex)
                {
                    ViewBag.Message = ex.Message;
                    return View();
                }
                //                
            }
            return View();
        }
    }
}